/*
-------------------------------------------------------------------------------
    This file is a part of the Vst Preset Generator
    Copyright (C) 2007  Francois Mazen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-------------------------------------------------------------------------------
  Name: fxheader.h
  Author: Francois Mazen
  Date: 28/05/07 16:25
  Description: header for the FxHeader class
-------------------------------------------------------------------------------
*/


#ifndef FXHEADER_H
#define FXHEADER_H

#include <QObject>

struct FxHeaderStruct
{
       QString name; 		//name of the Plug-in
       QString fxID; 		//unique ID
       qint32 fxVersion; 	//Plugin version
       qint32 nParams;		//number of parameters
       bool useChunk;		//true if the plugin uses the opaque chunk method
       QString fxPath;
};

class FxHeader : public QObject
{
      Q_OBJECT
      
public:
       FxHeader();
       ~FxHeader();
       
       FxHeaderStruct Data;
       
public slots:
      void receiveParameters(FxHeaderStruct* dat);

signals:
       void headerIsValid(bool boolean = true);

      
}; 

#endif //FXHEADER_H
