/*
-------------------------------------------------------------------------------
    This file is a part of the Vst Preset Generator
    Copyright (C) 2007  Francois Mazen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-------------------------------------------------------------------------------
  Name: vpgvsthost.h
  Author: Francois Mazen
  Date: 13/06/07 17:50
  Description: header file of the VpgVstHost class
-------------------------------------------------------------------------------
*/

#ifndef VPGVSTHOST_H
#define VPGVSTHOST_H


#include "vst2.x/aeffectx.h"

#include "windows.h"

#define ERROR_PLUGIN_LOAD 1
#define ERROR_PLUGIN_MAIN 2
#define ERROR_PLUGIN_INSTANCE 3
#define ERROR_PLUGIN_VALID 4


class QLibrary;
class QString;

const int blocksize=512;
const float samplerate=44100.0f;

VstIntPtr VSTCALLBACK host(AEffect *effect, VstInt32 opcode, VstInt32 index, VstInt32 value, void *ptr, float opt);




//-----------------------------------------------------------------------------
// VpgVstHost
//-----------------------------------------------------------------------------

class VpgVstHost 
{

public:
       VpgVstHost();
       
       //int Load(const wchar_t* filename);
       int Load(QString filename);
       void Close();
       bool isVstLoaded();
       
       VstInt32 getFxId();
       VstInt32 getFxVersion();
       VstInt32 getNumberParams();
       VstInt32 getNumberPrograms();
       void getParamName(VstInt32 index, char* buffer);
       char* getName();
       bool useChunk();
       
       void setParameter(long index, float value);
       void setProgram(long num);
       void setProgramName(const char* name, long index);
       VstInt32 getProgramChunk(void** chunk); 
       VstInt32 getBankChunk(void** chunk);
       
       
       
private:  
       //create a pointer for the plugin we're going to load
	   AEffect* ptrPlug;
	   //HINSTANCE libhandle;
	   QLibrary* library;
	   
        
        
        
};




#endif //VPGVSTHOST_H
